 program sndrbufr
      implicit none
      integer  mxtb,mchn,nparm
      parameter(mxtb=100000,mchn=700)
      parameter(nparm=10)

      character(30)satid,head
      character(8) subset
      real(8)      tab(nparm,mxtb),xy(2),brit(2,mchn),bmiss,quash
      !  brit(1,i): Channel   number in bufr file
      !  brit(2,i): Brightness temperature in bufr file
      character(80) str,strh
      real(4)      tb(mchn),rad(mchn)
      real(4)      dist
      integer      i,ii,j,l,n,nn
      integer      nchan,ichan(mchn),nrec,nchn
      !  nchan: number of channel simulated and saved in ascii file
      !  nchn: number of channel in bufr file
      !  ichan:  channel simulated and saved inascii file
      !  tb :  Brightness temp in ascii file 
      real         blat,blon,bhour,dlat,dlon,dhour,rlon,rlat,hour
      real         dmiss,saza,soza,dmin,eps
      integer      imon,iyear,iday,imo,iyr,idy
      integer      ntab,iunit,nct,nwrite,lunin,lunot,lundx,luthn
      integer      idate_in,isub,irec,iret,idate_out,idate
      integer      istype
      integer      iprt
      integer       il,im,lun
      integer       ihr,imin,sec
      integer       sat_type,tyear,mask
      real          usr
      integer       ntab_test

      data bmiss/10e10/dmiss/9e10/eps/0.00001/
      data quash/10e09/
      data str/'CLON CLAT IREC ISUB YEAR MNTH DAYS HOUR MINU SECO'/
      data strh/'CLONH CLATH IREC ISUB YEAR MNTH DAYS HOUR MINU SECO'/
      data iprt/0/

!-------------------------------------------------------------------
!-------------------------------------------------------------------

      lunin=20; lundx=22; luthn=22; lunot=50
!     read(*,'(4i3)') lunin, lundx, luthn, lunot
      read*,tyear
      read*,mask
      read*,sat_type
      read*,iprt
      print*,' tyear,mask,sat_type',tyear,mask,sat_type
       print*,' start asc2bfr ',lunin, lundx, luthn, lunot


! open input and output bufr files
      if ( sat_type .eq.4 .or. sat_type.eq.5)then
      print*,' hires IR'
      call ufbtab(luthn,tab,nparm,mxtb,ntab,strh) 
      else
      call ufbtab(luthn,tab,nparm,mxtb,ntab,str) 
      endif
      print*,' ntab=',ntab
      if (iprt.ge.4) then
        ntab_test=10
      else
        ntab_test=ntab
      endif
      if (iprt.ge.4) then
        print*,'////////  tab /////////'
        print*,str
        do n=1,ntab_test
           bhour=tab(8,n)+tab(9,n)/60.+tab(10,n)/3600.
           print '(i10,8(f10.3),3(f15.7))',n,(tab(i,n),i=1,nparm),&
               bhour
        enddo
      endif
      call ufbmem(luthn,0,iret,iunit)

      !call openbf(luthn,'IN ',luthn) 
      call openbf(lunot,'OUT',luthn)

! read a simulated record

      !read(lunin,*) ! skip the first record
      nrec=0
      nwrite=0
10    read(lunin,'(I10,A15,7I10)',end=100)&
                    nct,satid,istype,iyr,imo,idy,nchan  
      satid=adjustl(satid)
      read(satid,'(a6)')head
      read(lunin,'(9f10.3)') rlat,rlon,hour,saza,soza
      if (iprt.ge.3) then
          print*,' =========  Profile read ======'
          print*,nct,satid,istype,iyr,imo,idy,nchan
          print*,' head ',head
          print*,rlat,rlon,hour,saza,soza
      endif
      do l=1,nchan
        read(lunin,1000)ichan(l),tb(L)
          if (iprt.ge.5) then
              print*,l,ichan(l),tb(L)
          endif
         if (l.ne.ichan(l)) then
              if (sat_type.ne.4) then
              print*,' mismatch in channel ',l,ichan(l)
              stop
              endif
          endif
       enddo
      nrec=nrec+1
1000 format(i6,f10.3)

! read the thinned report paired with the simulated record
      nn=-999
      dmin=999.
      do n=1,ntab_test
         iyear=nint(tab(5,n));imon=nint(tab(6,n));iday=nint(tab(7,n))
         bhour=tab(8,n)+tab(9,n)/60.+tab(10,n)/3600.
         blon=tab(1,n);blat=tab(2,n)
         dhour=abs(bhour-hour)
         dlon=abs(rlon-blon);dlat=abs(rlat-blat)
         dist=sqrt(dlon**2+dlat**2)
          if (iprt.ge.4) then
         print*,str
           print '(i10,3(1pe10.3),5(f8.2),3(f13.7))',n,(tab(i,n),i=1,nparm),&
               bhour
          if (iprt.ge.5) then
           print*,'n,hour,bhour,dhour,tab(8,n),tab(9,n),tab(10,n)'
           print*,n,hour,bhour,dhour,tab(8,n),tab(9,n),tab(10,n)
           print*,'rlat,rlon,blat,blon,dist',rlat,rlon,blat,blon,dist
          endif
         endif

         if (dhour.lt.0.01) then
             if (dist.lt.dmin)then
                nn=n
                dmin=dist
                if (iprt.ge.4) print*,' nn was updated to ',nn 
             endif 
         endif
      enddo
         if (nn.eq.-999) then
           print*,' cannot find matching time for',nrec,rlon,rlat,hour
           go to 10
         endif
         iyear=nint(tab(5,nn));imon=nint(tab(6,nn));iday=nint(tab(7,nn))
         bhour=tab(8,nn)+tab(9,nn)/60.+tab(10,nn)/3600.
         blon=tab(1,nn);blat=tab(2,nn)
         if (tyear.eq.2009) then
           iyear=iyear-4
         endif
         if (iyear.ne.iyr.or.imon.ne.imo.or.iday.ne.idy) then
          print*,' date does not match  '
          print*,' simulated data ',iyr,imo,idy,' template ',iyear,imon,iday
          stop
         endif
         if (dmin.ge.1.0) then
            print*,'$$$$$$$$$$$$$ dmin too large skipping  this data',dmin
            print*,' rec=',nrec,' match nn=',nn
            print*,'rlon,rlat,hour,blon,blat,bhour'
            print*,rlon,rlat,hour,blon,blat,bhour
            ihr=int(hour)
            imin=int((hour-ihr)*60.0)   
            sec=int((hour-ihr)*3600-imin*60.0)
            print*,'hr,min,sec in DBL91',ihr,imin,sec 
            print*,'hr,min,sec in template',tab(8,nn),tab(9,nn),tab(10,nn) 
            go to 10
         endif
         if (iprt.ge.4) then
          print*,' rec=',nrec,' match nn=',nn,' nct=',nct
          print*,rlon,rlat,hour,blon,blat,bhour
         endif
      tab(1,nn)=bmiss;tab(2,nn)=bmiss
      irec=tab(3,nn);isub=tab(4,nn)
      call ufbmms(irec,isub,subset,idate_in)

! copy report into bufr

      if (tyear.eq.2009.or.tyear.eq.2010) then
      idate_out=idate_in+4000000
      else if (tyear.eq.2005.or.tyear.eq.2006) then
      idate_out=idate_in
      else
       print*,'tyear=',tyear ,'is not ready'
      endif
      call openmb(lunot,subset,idate_out)
      call ufbcpy(luthn,lunot)

      call ufbrep(luthn,brit,2,mchn,nchn,'CHNM TMBR')
      if (iprt.ge.4) print*,'nchn in thinbufr ',nchn
      if (nchn <>nchan) then
         if (iprt.ge.2) then
             print*,'  number of channel does not match ',nchn,nchan
         endif
      endif
!     channel which are not included in the template  is treated as missing
      do i=1,nchn
       ii=-999
       do j=1,nchan 
           if(ichan(j).eq.nint(brit(1,i))) then
             ii=j
             if (brit(2,i)<dmiss) then
               if ( mask.eq.1) then
                  if (brit(2,i) > eps) then
                     brit(2,i)=tb(j)      ! masked data
                  else
                      brit(2,i)=bmiss
                  endif
               else
                  brit(2,i)=tb(j)      ! masked data
               endif
             else
               brit(2,i)=bmiss
             endif
           endif
        enddo 
       if (ii.eq.-999) then
             brit(2,i)=bmiss
       endif
      enddo
      call ufbrep(lunot,brit,2,nchn,iret,'CHNM TMBR')

! remove some existing data from real goes files

      if (sat_type.eq.3) then
      ! Goes data
      call ufbint(lunot,quash,1,1,iret,'BDRF   ')
      call ufbint(lunot,quash,1,1,iret,'GLFTI  ')
      call ufbint(lunot,quash,1,1,iret,'CLAM   ')
      call ufbint(lunot,quash,1,1,iret,'CDTP   ')
      call ufbint(lunot,quash,1,1,iret,'GCDTT  ')
      call ufbint(lunot,quash,1,1,iret,'TMSK   ')
      call ufbint(lunot,quash,1,1,iret,'TCSF   ')
      call ufbint(lunot,quash,1,1,iret,'PH2O   ')
      call ufbint(lunot,quash,1,1,iret,'PH2O19 ')
      call ufbint(lunot,quash,1,1,iret,'PH2O97 ')
      call ufbint(lunot,quash,1,1,iret,'PH2O73 ')
      call status(lunot,lun,il,im) ! get rid of prlc profile
      call string('PRLC',lun,1,1)   
      call trybump(lunot,lun,usr,0,0,1,iret)
      endif

! write the simulated reord out

      call writcp(lunot)
      nwrite=nwrite+1
      go to 10 

! here at the end

100   call closbf(lunot)
      print*,' number of data in template ',ntab
      print*,' number of data in ascii ',nct
      print*,' number of data read ',nrec, ' written ',nwrite
      print*,' Nchan in template ',nchn,' Nchan in CRTM',nchan
      stop
      end
