  SUBROUTINE Read_NR_Record( luprof, init,Sensor_Id ,&  ! Input
                               sat_type, &
                               Atm , &  ! Output
                               Sfc,  &  !  OutPut
                               GeometryInfo, &   ! Output
                               nprof,&
                               Message_Log, &  ! Error messaging
                               year,month,day,hour, crtm_stype,&                             
                               EOF1,IPRT)!  number of profile read
!
! Subroutine Read_NR_Record
!
!
! CREATION HISTORY:
!       Based  on code written by:   Tong Zhu 
!       Modified to subroutine by :
!                       Michiko Masutani  09-Oct-2009
!                       Supported by David Groff
  ! ============================================================================
  ! **** ENVIRONMENT SETUP FOR RTM USAGE ****
  !
  ! Module usage
  USE CRTM_Module
  !  USE CRTM_surface_ir_emissivity
  USE Fundamental_Constants
  IMPLICIT NONE
  !INTEGER,PARAMETER::fp_kind=4
  ! Disable all implicit typing
  ! ============================================================================
  INTEGER,PARAMETER :: Kmax=100
  ! ...but only ONE Sensor at a time
  ! Test GeometryInfo angles. The test scan angle is based
  ! on the default Re (earth radius) and h (satellite height)
  ! ============================================================================


  ! ---------
  ! Variables
  ! ---------
  CHARACTER(*) :: Sensor_Id
  CHARACTER(*) :: Message_Log
  CHARACTER(10)::Head
  CHARACTER(10)::sate
  INTEGER :: Error_Status
  INTEGER :: Allocate_Status
  INTEGER :: Sensor, Channel
  INTEGER:: CloudType, AerosolType
  !  REAL( fp_kind ) :: a,  u, v
  INTEGER:: lnr  ! Layer used
  INTEGER :: rec, irec
  INTEGER :: n_level,n_layer
  INTEGER :: year, month, day,jday
  INTEGER i,j,n, l, k, m, k1,k2,ll
  REAL(fp_kind),parameter::distance_ratio = 0.888424_fp_kind ! default value for
                                ! (earth_radius/(earth_radius+satellite_height)
  REAL( fp_kind ):: terr, ptop,ttop,u10m,v10m
  REAL( fp_kind ):: saza,soza,sazm,hour,cldt,cldl,cldm,cldh,alon,alat
  REAL(fp_kind)::saza1,soza1,satlat,satlon,fov,scan_start,scan_step
  REAL(fp_kind ),DIMENSION(Kmax):: cov,ice,h2o,o3,temp,sph,plev,psig
  real(fp_kind)::scan_angle
!
!
  INTEGER nclm, nsfc,nclm1,nsfc1,n_aero
  INTEGER mclm,msfc,msat,isvar,icvar
  parameter (msfc=100,msat=50,mclm=20)
  REAL(fp_kind)::ecclm(mclm),ecsfc(msfc)
  character(80) filenm,istxt,climd
!  common /sfcobs/ nsfc1,isvar(msfc),istxt(msfc)
!  common /climobs/ nclm1,icvar(mclm),climd(mclm)
!
!
  INTEGER,INTENT(IN)::nprof
  INTEGER:: luprof,iostat,init,IPRT,EOF1
  INTEGER::crtm_stype 
  INTEGER:: sat_type  !  sat_type will be used to control surface etc
!
!  sat type 1: Micro 2; IR Hirs 3: GOES  4:AIRS IASI
!

  REAL(fp_kind)::scover,atmp,deg2rad,pi_1

  ! ============================================================================
  ! 1. **** DEFINE THE CRTM INTERFACE STRUCTURES ****
  !
  TYPE(CRTM_GeometryInfo_type)       :: GeometryInfo
  TYPE(CRTM_Atmosphere_type)       :: Atm
  TYPE(CRTM_Surface_type)          :: Sfc
  !==========================================================================
       Error_Status=999
       pi_1=3.141592653589793238462643_fp_kind
       deg2rad=PI_1/180.0_fp_kind
      

       if (init==1) then
       open(luprof,form='unformatted')
       init=0
       endif
        sate=Sensor_ID
        read(sate,'(a6)') HEAD
        call  read_DBL91(luprof,iostat,IPRT,init,&
        sate, Kmax,lnr, year,month,day,&
        fov,saza,soza,sazm,hour,&
        plev,psig,cov,ice,h2o,o3,temp,sph,&
        nclm,ecclm,nsfc,ecsfc,&
        ptop,ttop,n_aero,alat,alon,nprof)


        if (iostat.ne.0)  then
          EOF1=1
          return
        endif
!
!
      if (IPRT.ge.4) then
        print*,'in RDNR  nprof '
        print*,'nprof,iostat,IPRT,init,Kmax,lnr'
        print*,nprof,iostat,IPRT,init,Kmax,lnr
        print*,'luprof,iostat,year,month,day,hour'
        print*,luprof,iostat,year,month,day,hour
        print*,'alat,alon,ptop,ttop,u10m,v10m'
        print*,alat,alon,ptop,ttop,u10m,v10m
        print*,'saza,soza,sazm,hour,cldt,cldl,cldm,cldh'
        print*,saza,soza,sazm,hour,cldt,cldl,cldm,cldh
        print*,' surface skin temp ',ecsfc(56)
      endif

      if (IPRT.ge.4) then
      print*,' in RDNR, '
      print*,'psig(k),plev(k),cov(k),ice(k),h2o(k),o3(k),temp(k),sph(k)'
      do k=1,lnr,5
      print'(8e12.4)',psig(k),plev(k),cov(k),ice(k),h2o(k),o3(k),temp(k),sph(k)
      enddo
      print*
      endif
!#############  save to Atmosphere
      Atm%n_Absorbers=2
      Atm%n_Clouds = 2
      Atm%n_Aerosols = 0
      Atm%n_Layers = lnr
      Atm%Climatology    =  INVALID_MODEL
      Atm%Absorber_Id    = (/ H2O_ID                 , O3_ID /)  ! (/1,3/)
      Atm%Absorber_Units = (/ MASS_MIXING_RATIO_UNITS, VOLUME_MIXING_RATIO_UNITS /)
      Atm%Cloud(1)%Type  = WATER_CLOUD ! 1
      Atm%Cloud(2)%Type  = ICE_CLOUD  ! 2

      Atm%Level_Pressure(0) = ptop
      if (iprt.ge.5) then
      print*,'psig(k),plev(k),ice(k),h2o(k),o3(k)(GSI),temp(k),sph(k)(kg/kg)'
      endif
      do l=1,Atm%n_Layers
      ll=l           ! l=0 top
      Atm%Level_Pressure(l)=plev(ll)
      Atm%Pressure(l)=psig(ll)
      Atm%Temperature(l)=temp(ll)
      Atm%Absorber(l,1)=sph(ll)
      Atm%Absorber(l,2)=o3(ll)
      IF( Atm%Absorber(l,1) < 1.E-7 ) Atm%Absorber(l,1)=1.E-7  ! sph
      IF( Atm%Absorber(l,2) < 1.E-10 ) Atm%Absorber(l,2)=1.E-10  ! O3
      Atm%Absorber(l,1) = 1000.0 * Atm%Absorber(l,1)! Kg/g to g/g conversion
      Atm%Absorber(l,2) = 604229.0 * Atm%Absorber(l,2)   ! see GSI
      atmp = 100.0*(Atm%Level_Pressure(l)-Atm%Level_Pressure(l-1))/9.8
      Atm%Cloud(1)%Water_Content(l)=atmp*H2o(ll)
      Atm%Cloud(2)%Water_Content(l)=atmp*Ice(ll)
      Atm%Cloud(1)%Effective_Radius(l) = 8.0
      Atm%Cloud(2)%Effective_Radius(l) = 15.0
      Atm%Cloud(1)%Effective_Variance(l) = 2.0
      Atm%Cloud(2)%Effective_Variance(l) = 2.0
      if (iprt.ge.5) then
        print '(8(1pe12.4))', &
        Atm%Pressure(l),&
        Atm%Level_Pressure(l),&
        Atm%Cloud(2)%Water_Content(l),&
        Atm%Cloud(1)%Water_Content(l),&
        Atm%Absorber(l,2),&
        Atm%Temperature(l),&
        Atm%Absorber(l,1)
      endif
      enddo
!
!

!     set sfc type
        crtm_stype=-999
        !     routine in    RTM_surface_ir_emissivity.f90
        call StypeGFS2CRTM(Atm,Sfc,crtm_stype,ecclm,ecsfc,iprt)
        if (crtm_stype.eq.-999) then
                print*, ' stype is not defined ',crtm_stype
                stop
        endif 
        if (iprt.ge.4) then
          print*,'crtm_stype sfctemp ',crtm_stype,'   ', &
            Sfc%water_temperature  , & 
            Sfc%land_temperature   , &
            Sfc%ice_temperature    , & 
            Sfc%snow_temperature   , & 
            Sfc%soil_temperature      
        endif
!
!
  ! 4b. GeometryInfo input
  !  If these are not requied for simulation, 
  !  these information for GSI will be surplied when Bufr data is written.
  ! ----------------------
  ! All profiles are given the same value
     call date2jday(year,month,day,jday)
    read(Sensor_ID,'(a6)') Head
    
    call get_scan_angle(Sensor_ID,sat_type,fov,scan_angle,iprt)
    if  (Head == 'sndr_g' ) then
         if(Sensor_ID.eq.'sndr_g10') then
           satlon=-135.0
           satlat=0.0
         else if(Sensor_ID.eq.'sndr_g12') then
           satlon=-75.0
           satlat=0.0
         else
           print*,' information is not ready '
           print*,' Sensor_ID=',Sensor_ID
           stop
         endif


     call sazasoza(jday,satlon,satlat,alon,alat,hour,saza1,soza1)
     GeometryInfo%Sensor_Zenith_Angle=saza1   ! this fill fail buffering
     GeometryInfo%Source_Zenith_Angle =soza1
     GeometryInfo%Sensor_Azimuth_Angle =sazm  !not used
     GeometryInfo%Source_Azimuth_Angle = 0.0  ! not used
     GeometryInfo%Sensor_scan_Angle= 0.0  !in degree
     GeometryInfo%iFOV= nint(FOV)   !in degree
    else
     GeometryInfo%Sensor_Zenith_Angle=saza   ! this fill fail buffering
     GeometryInfo%Source_Zenith_Angle =soza
     GeometryInfo%Sensor_Azimuth_Angle =sazm   !not used  ?
     GeometryInfo%Source_Azimuth_Angle = 0.0   ! not used  ?
     GeometryInfo%Sensor_scan_Angle= scan_angle   !in degree
     GeometryInfo%iFOV= nint(FOV)   !in degree
    endif
     GeometryInfo%Surface_Altitude=ecsfc(13)/STANDARD_GRAVITY  
     GeometryInfo%Longitude=alon  ! Earth Location in degree
     GeometryInfo%Latitude=alat  ! Earth Location in degree
     GeometryInfo%Flux_Zenith_Angle=DIFFUSIVITY_ANGLE 
                         ! defined in parameter


      
!##################################
      if (iprt.ge.3) then
      print*,' profile ',nprof,' read'
      endif
      end  SUBROUTINE  Read_NR_Record
!
