  subroutine get_scan_angle(Sensor_ID,sat_type,fov,scan_angle,iprt)
!  
!  Added by Michiko Masutani  February 2009 
!      Step and start are Based on GSI code 
!      probably these variable are not used by CRTM
!  Set invalid values for AIRS and IASI:  Haibing Sun  March 2009  
!
  USE Type_Kinds
  USE Fundamental_Constants
  IMPLICIT NONE
  real(fp_kind), intent(in)::fov
  real (fp_kind), intent(out)::scan_angle
  real(fp_kind)::step,start 
  real(fp_kind)::one,three,deg2rad
  integer::iprt
  character(*), intent(in)::Sensor_ID
  character(10)::head3,head4,head5,head6,head7,head8,sid
  integer::iscan
  integer:: sat_type  !  sat_type will be used to control surface etc
!
!  sat type 1: Micro 2; IR Hirs 3: GOES  4:AIRS IASI
!

  sid=adjustl(Sensor_ID)
  read(sid,'(a3)') head3
  read(sid,'(a4)') head4
  read(sid,'(a5)') head5
  read(sid,'(a6)') head6
  read(sid,'(a7)') head7
  read(sid,'(a8)') head8

  deg2rad=PI/180.0_fp_kind
  step=9999.00_fp_kind
  start=9999.00_fp_kind
  one=1.0_fp_kind
  three=3.0_fp_kind
  
!  if (head4=='airs')then
!     step   = 1.1_fp_kind
!     start = -48.9_fp_kind
  if(head5=='amsua')then
     ! both NOAA and aqua
     step   = three + one/three
     start = -48._fp_kind - one/three
  else if ( head5=='amsub' )  then
      ! both NOAA and aqua
     step   = 1.1_fp_kind
     start  = -48.95_fp_kind
  else if(head3=='hsb')then
     step   = 1.1_fp_kind
     start  = -48.95_fp_kind
  else if ( head4=='hirs' ) then
     step   = 1.80_fp_kind
     start  = -49.5_fp_kind
  else if ( head3=='msu' ) then
     step   = 9.474_fp_kind
     start  = -47.37_fp_kind
  else if ( head6=='sndr_g' ) then
     step   = 0.0_fp_kind
     start  = 0.0_fp_kind
  else if (sat_type.eq.4) then
     step=0.0_fp_kind
     start=90.00_fp_kind 
     !print*,' scan angle is not used by CRTM '
     !print*,'  set to unrealistic value '
  else
     if (iprt.ge.2) then
         print*,' Sensor_ID ',Sensor_ID, '  is not ready'
     endif
     !print*,' scan angle is not used by CRTM '
     !print*,'  set to unrealistic value '
     step=0.0_fp_kind
     start=90.00_fp_kind 
  end if
  scan_angle=(start + (fov-one)*step)*deg2rad
  return
  end subroutine get_scan_angle
