        subroutine  read_DBL91(luprof,iostat,iprt,init,&  
        sate, Kmax,lnr, year,month,day,&
        fov,saza,soza,sazm,hour,&
        plev,psig,cov,ice,h2o,o3,temp,sph,&
        nclm,ecclm,nsfc,ecsfc, &
        ptop,ttop,n_aero,alat,alon,n_prof)
!
!     This program read DBL91. The code combine
!     give name to variable for eaier use 
!     rdthin.f by Jack Woollen 
!     modified by   - Tong Zhu March 2008
!     modified Michiko Masutani August 2009
!           read surface variables from ECMWF
!     modified Michiko Masutani January 2010 
!           set surface variable from gfs
!
      USE CRTM_Module
      implicit none
      integer,intent(in)::n_prof
      integer n, l, k, m
      integer,intent(in):: luprof,iprt,Kmax
      integer,intent(in out)::init
      integer,intent(out)::iostat,lnr
      integer:: nupr, nsat, lusfcvar
      integer::luwk1,luwk2
      data luwk1/60/luwk2/61/
!
!
      integer nclm, nsfc,nclm1,nsfc1
      integer mclm,msfc, msat,isvar,icvar
      parameter (msfc=100,msat=50,mclm=20)
      character(80) filenm,istxt,climd
      common /sfcobs/ nsfc1,isvar(msfc),istxt(msfc)
      common /climobs/ nclm1,icvar(mclm),climd(mclm)
!
!
      character(50) satnd(16)
      character(10) upprd(6),upprv(6)
      real(fp_kind):: ecclm(*),ecsfc(*)
      real(4):: clim(4),satn(msat),surf(msfc),psig1(Kmax),uppr(Kmax,6)
      real(fp_kind):: cov(Kmax),ice(Kmax),h2o(Kmax),o3(Kmax),&
            temp(Kmax),sph(Kmax),psig(Kmax),plev(Kmax)
      data lusfcvar/10/
      real(fp_kind) gg
      data gg /9.80665/     !m/s**2 gravity constant
      real(fp_kind):: ptop, ttop
      real(fp_kind):: terr,alat,alon,hour,u10m,v10m
      real(fp_kind):: saza,soza,sazm,cldt,cldl,cldm,cldh
      real(fp_kind)::fov,scan_start,scan_step
      real(fp_kind):: saza1,soza1

      integer:: year, month, day, jday   !Julian Day
      integer:: n_aero,nct

      character(10) sate
      character(16) File_Prefix
      real(fp_kind) satlon, satlat

!  define the satellite elements
!  -----------------------------

      satnd( 1) = '004001  YEAR  YEAR         YEAR                   '
      satnd( 2) = '004002  MNTH  MONTH        MONTH                  '
      satnd( 3) = '004003  DAYS  DAY          DAY                    '
      satnd( 4) = '004004  HOUR  HOUR         HOUR                   '
      satnd( 5) = '004005  MINU  MINUTE       MINUTE                 '
      satnd( 6) = '004006  SECO  SECOND       SECOND                 '
      satnd( 7) = '006002  CLON  DEGREES      LONGITUDE              '
      satnd( 8) = '005002  CLAT  DEGREES      LATITUDE               '
      satnd( 9) = '001007  SAID  CODE TABLE   SAT IDENTIFIER         '
      satnd(10) = '002019  SIID  CODE TABLE   SAT INSTRUMENTS        '
      satnd(11) = '005043  FOVN  NUMERIC      BEAM POSITION          '
      satnd(12) = '008012  LSQL  CODE TABLE   LAND/SEA QUALIFIER     '
      satnd(13) = '007024  SAZA  DEGREE       SAT ZENITH ANGLE       '
      satnd(14) = '007025  SOZA  DEGREE       SOLAR ZENITH ANGLE     '
      satnd(15) = '010001  HOLS  METER        HEIGHT OF LAND SURFACE '
      satnd(16) = '007002  HMSL  METER        HEIGHT OR ALTITUDE     '

!  define the climate values
!  -------------------------

      climd(1)='iv=27 ! low  vegetation cover'
      climd(2)='iv=28 ! high vegetation cover'
      climd(3)='iv=29 ! low  vegetation type'
      climd(4)='iv=30 ! high vegetation type'
      icvar(1)=27
      icvar(2)=28
      icvar(3)=29
      icvar(4)=30
      nclm1=4

!  read in the list of surface values to include
!  ---------------------------------------------

      if (init.eq.1) then
      read*,filenm
      read*,sate
      print*,sate,'   ',filenm
      open(luprof,file=filenm,form='unformatted')
      open(lusfcvar,file='surface.lst');n=0
      open(lusfcvar);n=0
3     continue
      if(n+1.gt.msfc) then 
         print*,'n.gt.msfc   n=',n
         stop
      endif
   
      read(lusfcvar,'(5x,i3,4x,a80)',end=4)isvar(n+1),istxt(n+1)
      n=n+1; nsfc1=n
      go to 3
4     if (iprt.ge.3)print*,'read ',nsfc,' surface variable definitions'
      if(nsfc.gt.msfc) then
         print*,'nsfc.gt.msfc   nsfc=',nsfc
         stop
      endif
      init=0
      close(lusfcvar)
      endif



!  define the upper air values
!  ---------------------------

      upprd(1)=' cloud cov'; upprv(1)='    iv=248'
      upprd(2)=' cloud ice'; upprv(2)='    iv=247'
      upprd(3)=' cloud h2o'; upprv(3)='    iv=246'
      upprd(4)=' ozone mmr'; upprv(4)='    iv=203'
      upprd(5)=' tempature'; upprv(5)='    iv=130'
      upprd(6)=' spf humid'; upprv(6)='    iv=133'

!  open the thinned dbl91 file and read one record
!  -----------------------------------------------


      n_aero=0
      nct=0


      read(luprof,end=999) nsat,nclm,nsfc,nupr,lnr,(satn(m),m=1,nsat), &
                  (clim(m),m=1,nclm),(surf(m),m=1,nsfc), &
                 (psig1(l),l=1,lnr),((uppr(l,m),l=1,lnr),m=1,nupr)
      do m=1,nclm
        ecclm(m)=clim(m)
      enddo
      do m=1,nsfc
        ecsfc(m)=surf(m)
      enddo
      
      iostat=0

      year=satn(1)
      month=satn(2)
      day=satn(3)
      hour=satn(4)+satn(5)/60.+satn(6)/3600.

      alon=satn(7)
      alat=satn(8)
      if (iprt.ge.1) then
        write(luwk1,'(i10,3f10.3)')n_prof,alon,alat,hour
      endif


      saza=satn(13)
      soza=satn(14)
      sazm=0.0
      fov=satn(11)
      ttop=uppr(1,5)    !  Layer temp

      do l=1,lnr
         psig(l)=psig1(l)/100.0
      enddo
      do l=1,lnr-1
         plev(l)=(psig(l)+psig(l+1))/2.0
      enddo
      plev(lnr)=surf(25)/100.0

      ptop=0.005   !hPa       (Liu)    level= 2Pa=0.02hPa
                   ! ptop=plev(0)
      
      if (iprt.ge.5) then
        print*,'nsat,mclm,nsfc,nupr,lnr=',nsat,nclm,nsfc,nupr,lnr
        print*
        print'(f20.2,2x,a50)',(satn(m),satnd(m),m=1,16)                   
        print*
        print'(f20.5,2x,a50)',(clim(m),climd(m),m=1,nclm)
        print*,'----------'
        print'(f20.5,2x,2i5,2x,a50)',(surf(m),isvar(m),m,istxt(m),m=1,nsfc)
        print*,'----------'
   9     format(f20.5,2x,2i5,2x,a50)
        print*
        print'("    pres(pa)",6a12)',upprd
        print'("            ",6a12)',upprv
        print*
        print'(7e12.4)',(psig(k),(uppr(k,m),m=1,nupr),k=1,lnr,5)
        print*
      endif

      do k=1,lnr
        cov(k)=uppr(k,1)
        ice(k)=uppr(k,2)
        h2o(k)=uppr(k,3)
        o3(k)=uppr(k,4)
        temp(k)=uppr(k,5)
        sph(k)=uppr(k,6)     !  Kg/Kg  to be converted in 
      enddo

      if(n_prof.eq.1.and.iprt.ge.1) then
        print*,'in RDDBL91'
        print*,'n_prof=',n_prof,year,month,day,hour,alat,alon,saza,soza
      else if (iprt.ge.3) then
        print*,'in RDDBL91'
        print*,'n_prof=',n_prof,year,month,day,hour,alat,alon,saza,soza
      endif
      if (iprt.ge.5) then
      write(6,'(4i12)') year, month, day, n_aero
      print*,' sfc skin temp ',surf(56)
      do k=1,lnr,5
      write(6,'(8e13.4)') plev(k),psig(k),uppr(k,1),uppr(k,2),uppr(k,3),&
                           uppr(k,4),uppr(k,5),uppr(k,6)
      enddo
      endif

      return
999   continue
      print*,' EOF n_prof=',n_prof
      iostat=1 

      close(luprof)
      return
      end subroutine read_DBL91
!
