      subroutine sazasoza(jday,satlon,satlat,lon,lat,hour,saza,soza)
!     calculate saza and soza from time,lat/lon - Tong Zhu 07/17/2009
      use type_kinds
      implicit none
      integer:: jday
      real(fp_kind):: lon,lat,hour,saza,soza
      real(fp_kind):: tsm,pi,dtor,xlo,xla,xj,a1,a2,a3,et,tsv,ah,delta,cossza
      real(fp_kind):: satlon,satlat,xslon,xslat,betaa,aa

         !----- compute soza ------

         tsm = hour + lon/15.0
         pi = 3.1415926
         dtor = pi / 180.0
         xlo = lon * dtor
         xla = lat * dtor
         xj  = float(jday)
         a1  = (1.00554*xj-6.28306) * dtor
         a2  = (1.93946*xj+23.35089)* dtor
         et  = -7.67825*sin(a1) - 10.09176*sin(a2)
         tsv = tsm + et/60.0
         tsv = tsv - 12.0
         ah  = tsv*15.0*dtor
         a3  = (0.9683*xj-78.00878) * dtor
         delta=23.4856*sin(a3)*dtor
         cossza=cos(xla)*cos(delta)*cos(ah)+sin(xla)*sin(delta)
         soza = acos(cossza) / dtor  ! solar zenith angle  ?

         !----- compute saza ------

         xslon  = (lon-satlon) * dtor
         xslat  = (lat-satlat) * dtor
         betaa  = acos( cos(xslat) * cos(xslon) )
         aa=42164.0* sin(betaa)/ sqrt(1.808e09 - 5.3725e08*cos(betaa))
         if(abs(aa).gt.1.0) aa=1.0
         saza = asin(aa) / dtor  ! satelite zenith angle?

      return
      end

