#!/bin/bash
set -xv
CDATE=2005050200  # date for out put 
MASK=0  # vertical mask. use files in GDAS_thinsats.BUFRZ.masked.Sep09  as template
#
# =========================================
# set EXPID ID TDATE TYEAR
#   EXPID and ID
#TDATE=2005050200  # date used for template 
#TYEAR=2005
#
#EXPID=NC05.v1   # results are saved under $RESDIR0/$EXPID
#ID=.v2.nocl  # ID for exec for no cloud   (need .)
#
#EXPID=NC05_10Prof   # results are saved under $RESDIR0/$EXPID
#ID=.v2.nocl.test  # ID for exec for no cloud   (need .)  no cloud, process  10 foot print 
#
#EXPID=CL05.v1   # results are saved under $RESDIR0/$EXPID
#ID=.v2  # ID for exec  with cloud  (need .)
#
=================
TDATE=2009050200  # date used for template 
TYEAR=2009
#EXPID=NC09.v1   #  no cloud
#ID=.v2.nocl  # ID for exec for no cloud   (need .)
#
#EXPID=NC09_10Prof   # results are saved under $RESDIR0/$EXPID
#ID=.v2.nocl.test  # ID for exec for no cloud   (need .)  no cloud, process  10 foot print 
#
EXPID=CL09.v1   # results are saved under $RESDIR0/$EXPID
ID=.v2  # ID for exec  with cloud  (need .)
#
#=========================================
#  ID=.v2.nocl.test  # ID for exec for no cloud   (need .)  no cloud, process  10 foot print 
#  ID=.v2.nocl      Max profile is   100000  
#  ID=.v2      n_clouds=2
#  nocloud  ID=.v2.nocl
#   "read OK" is added to pause script
#  This sample script is seet to simulate NOAA16 HIRS3 for
#  2005050200
#  no vertical masking (MASK=0)
#==================
# Preparation
#
#  getCoefficient.sh : copy coefficient to local directory
#  ret_T511_dbl91.bash  : get DBL91
#    This script will call f the data is not ready but get messie
#  ret_thin_gdasrad.sh or ret_thin_mask_gdasrad.sh for template data
#    You can use thin sats data saved in 
#    This is also called by this script but better to preppare before hand
#  in this script retrieval scripts are switched off 
# 
# Specify test sensor ids
# v2   ocean is either ice or water no mixed surface
# nocl n_cloud=0
#
BASEDIR=/jcsda/save/$LOGNAME/work/SimRad/SimRad_CRTM1.2.2
export JOBDIR=$BASEDIR/NCEP.v2
# This script is forone time period
# data directory
DATADIR0=$BASEDIR/data
# results directory
RESDIR0=$BASEDIR/results
# working directory 
wkdir0=/ptmp/$LOGNAME/SimRad_wk
mkdir -p $wkdir0
# wkdir will be set later for each satellite 
mkdir $RESDIR0 $wkdir0
RESDIR=$RESDIR0/$EXPID
mkdir -p $RESDIR
#
# 2009 template
if [ $TYEAR -eq 2009 ];then
SID1=" airs281SUBSET_aqua  amsua_aqua  "
SID2=" amsua_metop-a hirs4_metop-a   "
SID3=" amsua_n15 amsub_n15  amsub_n16 hirs3_n16 amsub_n17 hirs3_n17"
SID4="  amsua_n18 hirs4_n18  "
SID5="   mhs_metop-a  mhs_n18  iasi616_metop-a   "  # scan angle will be set to 90.0
SENSOR_IDs=(dummy $SID1 $SID2 $SID3 $SID4 $SID5 )
nsat=15
else
SID1=" sndr_g10 sndr_g12 hirs2_n14 msu_n14  "
SID2=" amsua_n15 amsub_n15  amsub_n16 amsua_n16 hirs3_n16 amsub_n17 hirs3_n17"
#SID3=" airs281SUBSET_aqua  amsua_aqua  "
SENSOR_IDs=(dummy $SID1 $SID2 )
nsat=11
fi

#SENSOR_IDs=(dummy  iasi616_metop-a  )
#nsat=1
# faid for  mhs_n18
# nsat=1
#SENSOR_IDs=(dummy  sndr_g10 ) 
#nsat=1
#
#===================================================================
#
IPRT=0 # control the level of print out
isim=1  # sub CRTM
ibfr=1  # run convertion to bufr
icopy=1 # copy bufr file and ascii file to final directory
irefresh=1  # delete old data from temporary directory
copycoef=1
code=Big_Endian  #    This have to be sorted out  getCoefficient.sh
#
#
export SCRDIR=$JOBDIR/scripts
export UTILDIR=$JOBDIR/util
export EXECDIR=$JOBDIR/rad_src
export ASCBFR=$JOBDIR/asc2bfr
# copy this script to temporary directory for record
RUNSCRIPT=$0
#
#
# ===============================
#  Directories
# Basedirectory for scripts and code
#  set at the begining of the scripts
#  BASEDIR=/jcsda/save/$LOGNAME/work/SimRad/SimRad_CRTM1.2.2
#  BASEDIR contains most of 
#  code and scripts except for libraries in /nwprod
# ascii file: ascdir=${ascdir0}
ascdir0=$RESDIR
mkdir -p $ascdir0
echo "ascdir0=$ascdir0"
#
# final bufr file: bfr_res=$bfr_res0
bfr_res0=$RESDIR
mkdir -p $bfr_res0
#
# DBL91  data: saved in  $dir_dbl91
dir_dbl91=$BASEDIR/data/DBL91/$TDATE
mkdir -p $dir_dbl91
# GDAS template data : $gdasdir
if [ $MASK -eq 1 ];then
gdasdir=$BASEDIR/data/BUFRZ-mask/$TDATE
elif [ $MASK -eq 0 ];then
gdasdir=$BASEDIR/data/BUFRZ/$TDATE
fi
#
#===========================================================================
#
export CHK=$UTILDIR/chkfile # check the existance of file
export GRABBUFR=$UTILDIR/grabbufr  # block bufr data  do not need for thie data set but no harm
#====================================================================
#
#
echo " CDATE=$CDATE"
yymm=`echo $CDATE| cut -c 1-6`
#
#
i=1   # i=1 for goes12 i=2 goes10
#
while [ $i -le $nsat  ];do
#
#   start new data set
#
SID=${SENSOR_IDs[$i]}
DUMP_ID=`$SCRDIR/SID-DUMPID.bash  $SID x`
echo " DUMP_ID set to $DUMP_ID for SID=$SID"
sat_type=`$SCRDIR/SID-Sat-type.bash $SID`
# sat type 1: Micro 2; IR 3: GOES  4:Hires
echo " sat_type is set to $sat_type for SID=$SID "
#
RADFILE_HEAD0=${SID}.n_t511
RADFILE_HEAD=$RADFILE_HEAD0.${CDATE}
#
#
#
#////////////////////////////////////
#    Forward program could vary for the satellite type
Forward_FILE=Forward_ALL_gfs${ID}
#
#
if [ $TYEAR -eq 2009 ];then
bufrtab=$ASCBFR/bufrtab.2009.sat
elif [ $TYEAR -eq 2005 ];then
  if [ $sat_type -eq 3 ];then
    bufrtab=$ASCBFR/bufrtab.2005.goes
  else
    bufrtab=$ASCBFR/bufrtab.2005.sat
  fi
else
  echo  "TYEAR=$TYEAR  is invalid "
  exit
fi

#
#
#  Directoy to save bufr out put
#
#
#  Temprary directory for ASCII output
ascdir=$ascdir0    
mkdir -p $ascdir
echo "ascdir=$ascdir"
#read OK
#
#
wkdir=$wkdir0/${CDATE}_${SID}
mkdir -p $wkdir
echo "wkdir=$wkdir"
#read OK
cd $wkdir
cp $SCRDIR/$RUNSCRIPT .
#
#
#
#
#
CRTM_DIR=$BASEDIR/REL-1.2.2.JCSDA_CRTM  # location for libCRTM.a
#COEFDIR=$BASEDIR/CRTM_Rel_1.2.etc/CRTM_Coefficients 
# Copy appropriate formatted (big or little) coefficient used for the experiment from $COEFDIR to $coefdir
# run getCoefficient.sh
coefdir=$BASEDIR/CRTM_Coefficients 
cdir=$wkdir0/Coefficient_Data # copy data to make the file name short and visible
#  coefdir contains all fixed files requred to simulate ${SID}
constdir=$BASEDIR/CRTM_data   # extra data used 
mkdir -p $cdir
if [ $copycoef -eq 1 ];then
cp $coefdir/* $cdir
cp $constdir/* $cdir
fi
#
#
cd $wkdir
pwd
#
if [ $isim -eq 1 ];then
# run CRTM
cd $wkdir
# surface.lst will be assigned to fort.10
# Check that the example code has been compiled
# and is executable by the user.
#

if [ $irefresh -eq 1 ];then
rm -f $ascdir/$RADFILE_HEAD.ascii
# This will forced to execute  $FORWARD_file.exe
fi
ifile=`$CHK $ascdir/$RADFILE_HEAD.ascii`
if [ $ifile -eq 0 ];then
echo "  ascii file  $ascdir/$RADFILE_HEAD.ascii does not exist"
isim1=1
else
isim1=0
#  Although isim=1  $FORWARD_file.exe will not be executed bexause
#  ascci file is already created.
fi   # irefresh
#
if [ $isim1 -eq 1 ];then
set -xv
ls -l $dir_dbl91/${DUMP_ID}_${CDATE}.dbl91 
ifile=`$CHK $dir_dbl91/${DUMP_ID}_${CDATE}.dbl91`
if [ $ifile -eq 1 ];then
cp  $dir_dbl91/${DUMP_ID}_${CDATE}.dbl91  ${DUMP_ID}_${CDATE}.dbl91
else
echo " DBL91 file ${DUMP_ID}_${CDATE}.dbl91 does not exiet"
exit
fi  # ifile
#
#read OK 
cd $wkdir
OUTFILE=$RADFILE_HEAD.output
rm -rf  fort.*
#
#
ln -fs $cdir/AerosolCoeff.bin  AerosolCoeff.bin
ln -fs $cdir/CloudCoeff.bin  CloudCoeff.bin
ln -fs $cdir/EmisCoeff.bin EmisCoeff.bin
ln -fs $cdir/${SID}.SpcCoeff.bin ${SID}.SpcCoeff.bin
ln -fs $cdir/${SID}.TauCoeff.bin ${SID}.TauCoeff.bin
#ln -fs $cdir/abi_goesRall.OSS_VIS.txt ${SID}.OSS_VIS.txt  #  in CRTM abi_gr.SpcCoeff.bin 
ln -fs $cdir/topography.bin topography.bin   #  assign as fort.10
ln -fs $cdir/surface.lst surface.lst
#
rm -f fort.*
rm -f $RADFILE_HEAD.ascii
ln -s  $dir_dbl91/${DUMP_ID}_${CDATE}.dbl91  fort.20
ln -s $RADFILE_HEAD.ascii  fort.30
ln -s Latlonhr.dump fort.60

echo " start running  RTM " $RADFILE_HEAD.ascii
#$EXECDIR/$Forward_FILE.exe <<*NoMoreInput >$Forward_FILE.out
cp $EXECDIR/$Forward_FILE.exe  .
ls -l $Forward_FILE.exe
$Forward_FILE.exe <<*EOF
$IPRT
$sat_type
$SID
*EOF

ls -l $RADFILE_HEAD.ascii
if [ $icopy -ge 1 ];then
    cp  $RADFILE_HEAD.ascii $ascdir
fi  # icopy
#
fi # isim1
fi  # isim
#

#read OK

if [ $ibfr -eq 1 ];then
echo "start processing bufr data "
ibfr2=1
#  if ibfr2=0 do not execute bufrring and go to next satellite
BUFREX=$ASCBFR/asc2bufr.type.exe  
bfr_res=$bfr_res0  # keep same for for sample script
mkdir -p $bfr_res
echo " input data"
ls -l  $gdasdir/${DUMP_ID}_${TDATE}.bfr    # template data
ls -l  $ascdir/$RADFILE_HEAD.ascii
echo " output data "
echo  $bfr_res/$RADFILE_HEAD.bfr
if [ $irefresh -eq 1 ];then
rm -f  $bfr_res/$RADFILE_HEAD.bfr
fi
echo "CHK=$CHK" 
ifile=`$CHK $bfr_res/$RADFILE_HEAD.bfr`
if [ $ifile -eq 0 ];then
isim2=1
else
echo " refresh=1 is specified and  $bfr_res/$RADFILE_HEAD.bfr exist.   delete  "
rm -f $bfr_res/$RADFILE_HEAD.bfr
isim2=1
fi

if [ $isim2 -eq 1 ]; then
echo " bufr file does not exist start making bufr file "   
cd $wkdir
rm -f  fort.*
ifile=`$CHK $ascdir/$RADFILE_HEAD.ascii`
if [ $ifile -eq 0 ];then
echo " input file  $ascdir/$RADFILE_HEAD.ascii does not exiet"
ibfr2=0
fi

mmddhh=`echo $CDATE| cut -c 5-10`
BUFRZfile=${DUMP_ID}_${TDATE}.bfr
ifile=`$CHK $gdasdir/$BUFRZfile `
ls -l  $gdasdir/$BUFRZfile
if [ $ifile -eq 0 ];then
echo " input file  $gdasdir/${DUMP_ID}_${CDATE}.bfr does not exiet"
#echo "$retscript  $DUMP_ID  $CDATE $gdasdir"
#$retscript  $DUMP_ID  $CDATE $gdasdir
ibfr2=0
fi
#read OK
if [ $ibfr2 -eq 1 ];then
cp $gdasdir/$BUFRZfile .
$GRABBUFR $BUFRZfile $BUFRZfile.b
cp $ascdir/$RADFILE_HEAD.ascii $RADFILE_HEAD.ascii
rm -f fort.*
rm -f $RADFILE_HEAD.bfr
ln -s $BUFRZfile.b fort.22 #  template  bufr data
ln -s $RADFILE_HEAD.ascii fort.20
ln -s $RADFILE_HEAD.bfr fort.50
#   sat_type 3 and 5 need special handling 
$BUFREX  i<<*EOF
$TYEAR
$MASK
$sat_type
$IPRT
*EOF
if [ $icopy -ge 1 ];then
cp  $RADFILE_HEAD.bfr $bfr_res
fi   # icopy
fi   #ibfr2
fi   # isim2
fi   #ibfr
#
#
i=$(($i + 1))
echo " finish    SID=$SID"
echo "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
echo "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
echo "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
echo "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
done
#
echo " finish    CDATE=$CDATE"
echo "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
echo "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
echo "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
echo "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
